use Win32;
use Win32::Process;
use Win32::Process (STILL_ACTIVE);

$run_time = 60;
$sleep_buffer = 15;
$haircut_time = 0.3;

sub ErrorReport{
    print Win32::FormatMessage( Win32::GetLastError() );
}

sub run_customers_and_barbers {
	my($num_customers,$num_barbers) = @_;
	system("echo truncate table worklog\; | sqlplus -s scott/tiger");
	run_customers($num_customers);
	run_barbers($num_barbers);
}

sub run_customers {
	my($num_customers) = @_;
	$pid = fork;
	if($pid == 0) {
		exec("echo exec barber_shop.add_customers\($num_customers,$run_time\) | sqlplus -s scott/tiger");
	}
}

sub run_barbers {
	my($num_barbers) = @_;
	for($i=0;$i<$num_barbers;$i++)
	{
		$pid = fork;
		if($pid == 0) {
			#print "forked!\n";
			exec("echo exec barber_shop.add_barber\($haircut_time,$run_time\) | sqlplus -s scott/tiger");
		}
	}
}

sub test_num_customers {
system("echo create table barbershop_1 \(num_custs number, avg_wait number, max_wait number\)\; |  sqlplus -s scott/tiger");
system("echo truncate table barbershop_1\; |  sqlplus -s scott/tiger");
for (my $c = 1;$c<16;$c++) {
	printf("running $c customers with 3 babrbers\n");
	run_customers_and_barbers($c,3);
	sleep $run_time+$sleep_buffer;
	system("echo insert into barbershop_1 select $c,avg\(to_number\(replace(event,\'waited: \',\'\'\)\)\) as avg_wait,max\(to_number\(replace\(event,\'waited: \',\'\'\)\)\) as max_wait from worklog where event like \'waited:\%\'\; | sqlplus -s scott/tiger");	
	system("echo commit\;| sqlplus -s scott/tiger");
};

system("echo select \* from barbershop_1\ order by num_custs; |  sqlplus -s scott/tiger");
}

sub test_num_barbers {
	system("echo create table barbershop_2 \(num_barbers number, avg_wait number, max_wait number\)\; |  sqlplus -s scott/tiger");
	system("echo truncate table barbershop_2\; |  sqlplus -s scott/tiger");
	for (my $b=1;$b<9;$b++) {
		printf("running 3 customers with $b babrbers\n");
		run_customers_and_barbers(3,$b);
		sleep $run_time+$sleep_buffer;
		system("echo insert into barbershop_2 select $b,avg\(to_number\(replace\(event,\'waited: \',\'\'\)\)\) as avg_wait,max\(to_number\(replace\(event,\'waited: \',\'\'\)\)\) as max_wait from worklog where event like \'waited:\%\'\; | sqlplus -s scott/tiger");	
		system("echo commit\;| sqlplus -s scott/tiger");
	};

	system("echo select \* from barbershop_2\ order by num_barbers; |  sqlplus -s scott/tiger");
}

# under window, where fork behaves strangely, it is safer to run tests seperately (only one of the lines uncommented)
#test_num_customers;
test_num_barbers;


	







